Examples for the GUI library `Graphics.UI`
==========================================

* `Hello.curry`: a simple "Hello world" GUI
* `Counter.curry`: a simple counter GUI
* `Temperature.curry`:
  a converter from Celsius to Fahrenheit and Kelvin where the Celsius
  value of the temperature in Celsius is fixed by a slider
* `Calculator.curry`:
  a desk calculator showing the combination of GUIs with
  local state where the state is stored in an object
* `checkbutton.curry`: a simple demo for the use of checkbuttons
* `config.curry`: a simple demo to show the dynamic reconfiguration of
  widget parameters
* `events.curry`: a simple demo to show the handling of different events
   (e.g., left and right mouse buttons) inside one widget.
* `inputmask.curry`:
  a demo (simple address database) to show widgets in a tabular
  orientation by exploiting the `Matrix`
  construct for widget composition
* `Hilbert.curry`:
  drawing a Hilbert curve in a canvas widget
* `Sierpinski.curry`: drawing a Sierpinski curve in a canvas widget
* `Fractal.curry`: drawing a fractal curve in a canvas widget
* `mail.curry`: a simple mail widget to write and send an email
* `menu.curry`: a simple counter GUI to demonstrate the use of menu buttons
* `radiotraffic.curry`:
  a simple demo for the use of radiobuttons: traffic light controller
  ensures exclusion in traffic lights.
* `scrollbar.curry`:
  a simple demo for the use of scrollbars
* `textappend.curry`:
  a simple GUI demonstrating the use of `appendValue`
  in `TextEdit` widgets
* `textstyledappend.curry`:
  a simple GUI demonstrating the use of `appendStyledValue`
  in `TextEdit` widgets (where text can be shown with
  colors and font styles)
* `counter_controlled.curry`:
  a simple counter GUI which can be controlled not only by the user
  but also by external processes that send messages to the GUI
